unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, IdCookieManager, StdCtrls, IdServerIOHandler, IdSSLOpenSSL,
  IdIOHandler, IdIOHandlerSocket, idAuthentication, IdHeaderList,
  IdException, IdCookie, IdURI, IdGlobal;

type
  TForm1 = class(TForm)
    IdHTTP1: TIdHTTP;
    CookieManager: TIdCookieManager;
    Memo1: TMemo;
    IdSSLIOHandlerSocket1: TIdSSLIOHandlerSocket;
    BackupCookieManager: TIdCookieManager;
    email: TEdit;
    passwd: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    UseProxy: TCheckBox;
    Button1: TButton;
    procedure CookieManagerNewCookie(ASender: TObject;
      ACookie: TIdCookieRFC2109; var VAccept: Boolean);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses strutils, ComObj;

  function isExpiredCookie(c:TIdCookieRFC2109):boolean;
  var s:string;
  begin
    s:=c.Expires;
    result:=((Length(S) > 0) and (GMTToLocalDateTime(S) < Now)) or (c.Value='EXPIRED');
  end;

  function isCookieForPath(c:TIdCookieRFC2109; path:string):boolean;
  begin
    result:=true;{$Message warn 'implement this'}
  end;

procedure TForm1.CookieManagerNewCookie(ASender: TObject;
  ACookie: TIdCookieRFC2109; var VAccept: Boolean);
var i:integer;
begin
  i:=0;
  while (i<BackupCookieManager.CookieCollection.Count) and ((not sametext(BackupCookieManager.CookieCollection[i].CookieName, ACookie.CookieName))
    or (not sametext(BackupCookieManager.CookieCollection[i].Domain, ACookie.Domain)) or (not sametext(BackupCookieManager.CookieCollection[i].Path, ACookie.Path)))
    do
    inc(i);
  if i<BackupCookieManager.CookieCollection.Count then
  begin
    if isExpiredCookie(ACookie) then
    begin
//      if ACookie.CookieName<>'GA3T' then
        BackupCookieManager.CookieCollection[i].Free
    end                         else
      BackupCookieManager.CookieCollection[i].Assign(ACookie);
  end                                             else
    BackupCookieManager.CookieCollection.Add.Assign(ACookie);
  VAccept:=false;
end;

procedure TForm1.Button1Click(Sender: TObject);

  procedure saveit(html:string);// put a breakpoint in the end of this procedure to see all intermediary html responses
  begin
    with tfilestream.create('page.html',fmcreate) do
    try
      write(pansichar(html)^,length(html));
    finally
      free;
    end;
  end;

  procedure cleanupExpired;
  var i:integer;
  begin
    i:=0;
    while i<BackupCookieManager.CookieCollection.Count do
    begin
      if isExpiredCookie(BackupCookieManager.CookieCollection[i]) then BackupCookieManager.CookieCollection[i].Free
                                                                  else inc(i);
    end;
  end;

  procedure clearCookies;
  var j:integer;
  begin
    j:=0;
    while j<IdHTTP1.Request.RawHeaders.Count do
    begin
      if pos('Cookie'+IdHTTP1.Request.RawHeaders.NameValueSeparator, IdHTTP1.Request.RawHeaders[j])=1 then
        IdHTTP1.Request.RawHeaders.delete(j)                                                          else
        inc(j);
    end;
    j:=0;
    while j<IdHTTP1.Request.CustomHeaders.Count do
    begin
      if pos('Cookie'+IdHTTP1.Request.RawHeaders.NameValueSeparator{this is used when setting so it's ok}, IdHTTP1.Request.CustomHeaders[j])=1 then
        IdHTTP1.Request.CustomHeaders.delete(j)                                                                                                else
        inc(j);
    end;
    cleanupExpired;
  end;

{  procedure moveCookies;
//  var i:integer;
  begin
    while CookieManager.CookieCollection.Count>0 do
    begin
      BackupCookieManager.CookieCollection.Add.Assign(CookieManager.CookieCollection[0]);
      CookieManager.CookieCollection[0].Free;
    end;
//    CookieManager.CookieCollection.clear;
  end;  {}

  procedure setcookies(forUrl:string);
  var j, count:integer;
      all, cv:string;
      c:TIdCookieRFC2109;
      u:TIdUri;
  begin
//    moveCookies;
    clearCookies;

    count:=BackupCookieManager.CookieCollection.count;
    all:='';
    u:=TIdUri.Create(forUrl);
    for j:=1 to count do{$Message warn 'todo: order (if needed) according to path'}
    //If multiple cookies satisfy the criteria above, they are ordered in
    //the Cookie header such that those with more specific Path attributes
    //precede those with less specific. (section 4.3.4 from rfc2109)
    begin
      c:=BackupCookieManager.CookieCollection.Items[j-1];
      if c.IsValidCookie(u.Host) and isCookieForPath(c, u.Path) and not isExpiredCookie(c) then
      begin
        cv:=c.CookieName+'='+c.Value;
        IdHTTP1.Request.RawHeaders.Add('Cookie'+IdHTTP1.Request.RawHeaders.NameValueSeparator+' '+cv);
//        IdHTTP1.Request.CustomHeaders.Add('Cookie'+IdHTTP1.Request.RawHeaders.NameValueSeparator+' '+cv);// paros does this for some reason. not sure if it's needed
        all:=all+cv+'; ';// this might be needed to be done differently for different paths.
        // so if you have for example a set of cookies for / and anotehr one for /somepath, it might be needed to Cookie: list header entries.
        // didn't read the RFC for this so I am only guessing. for now, this works fine.
      end;
    end;
    if all<>'' then
    begin
      delete(all,length(all)-1,2);
//      IdHTTP1.Request.RawHeaders.Add('Cookie'+IdHTTP1.Request.RawHeaders.NameValueSeparator+' '+all);
      idhttp1.Request.CustomHeaders.Add('Cookie'+IdHTTP1.Request.RawHeaders.NameValueSeparator+' '+all);
    end;
    u.free;
  end;

  function getPage(url:string; postData:TStrings=nil; handleredirects:boolean=false):string;
  var u:string;
      i:integer;
  begin
//    application.processmessages;
    IdHTTP1.HandleRedirects:=handleredirects;
    setCookies(url);
    try
      if postData=nil then result:=idhttp1.Get(url)
                      else result:=idhttp1.Post(url, postData);
    except
      on e: EIdHTTPProtocolException do
      begin
        if (e.ReplyErrorCode div 100)<>3 then
           raise e;
          // now this is the redirect
          u:=IdHTTP1.Response.Location;
          if pos('://',u)=0 then// we need a valid location
          begin
           i:=posex('/',url,pos('.',url));
            if i>0 then
             delete(url,i,length(url));
            if url[length(url)]='/' then
              delete(url,length(url),1);
            if u[1]<>'/' then
             u:='/'+u;
            u:=url+u;
         end;

         result:=getpage(u, postData, handleRedirects);// follow redirect
      end;
      on e: EIdConnClosedGracefully do// workaround for what seems to be a connection closing from paros
        result:=getpage(url, postData, handleRedirects);
      on e: Exception do
        raise e;
    end;
    saveIt(result);
  end;
  
var Params: TStringList;
    HTML: String;
    ga3t, url:string;
    i:integer;
begin
  assert(email.text<>'');
  assert(passwd.text<>'');
  // mimic firefox
  idhttp1.Request.UserAgent:='Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.0.11) Gecko/20070312 Firefox/1.5.0.11';
  idhttp1.Request.Accept:='text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5';
  idhttp1.Request.AcceptLanguage:='en-us,en;q=0.5';
//  idhttp1.Request.Connection:='keep-alive';
//  idhttp1.Request.AcceptEncoding:='gzip,deflate';
  idhttp1.Request.AcceptCharSet:='ISO-8859-1,utf-8;q=0.7,*;q=0.7';
  idhttp1.Request.CustomHeaders.Add('Keep-Alive: 300');
  idhttp1.Request.CustomHeaders.Add('Connection: keep-alive');
  idhttp1.Request.ContentType:='';

  if useproxy.checked then
  begin
    idhttp1.ProxyParams.ProxyPort:=8080;
    idhttp1.ProxyParams.ProxyServer:='localhost';
  end;

  Params := TStringList.Create;

  try
    url:='https://www2.blogger.com/login.g';
    html:=getPage(url);
    // sets 1 cookie:
    // - S=blogger=GZToBYmGIRnzcAWwVvqszQ; Domain=.blogger.com; Path=/

    idhttp1.Request.Referer:=url;
    // send cookies: S=blogger=GZToBYmGIRnzcAWwVvqszQ
    i:=pos('iframe src=', html)+12;//12=length(iframe src=")
    url:=copy(html,i,posex('"',html,i)-i);
    url:=stringreplace(url,'&amp;', '&', [rfReplaceAll, rfIgnoreCase]);
    html:=getPage(url);
    // sets 2 cookies:
    // - GoogleAccountsLocale_session=en
    // - GA3T=r1jGWSDh6FA

    i:=posex('value',html,pos('GA3T', html))+7;// 7=length(value=")
    ga3t:=copy(html,i,posex('"',html,i)-i);
    Params.values['continue']:='http://www2.blogger.com/loginz?d=http%3A%2F%2Fwww2.blogger.com';
    Params.values['service']:='blogger';
    Params.values['nui']:='1';
    Params.values['naui']:='8';
    Params.values['fpui']:='2';
    Params.values['uilel']:='3';
    Params.values['skipvpage']:='true';
    Params.values['rm']:='false';
    Params.values['hl']:='en';
    Params.values['alfw']:='true';
    Params.values['alinsu']:='1';
    Params.values['GA3T']:=ga3t;
    Params.values['Email']:=email.text;//[email account here]
    Params.values['Passwd']:=passwd.text;//[password here]
//    Params.values['PersistentCookie']:='no';
    Params.values['rmShown']:='1';
    Params.values['null']:='Sign in';

    idhttp1.Request.Referer:=url;
    idhttp1.Request.ContentType:='application/x-www-form-urlencoded';
    // send cookies: GoogleAccountsLocale_session=en; GA3T=r1jGWSDh6FA
    HTML := getPage('https://www.google.com/accounts/ServiceLoginBoxAuth', params);
    // sets 8 cookies:
    // - GoogleAccountsLocale_session=en
    // - SID=DQAAAGoAAAAFMpqWBvaol9t61QDdcQkORiDRyy6laLqmxuWQ97Dcogq5o05Ndhmymk82SFnFVg6M0fveOe5ox4HQJsreaHZYAi1s3llAK27qh2usYkswJnSZVrd_Tx3XTk7OtxQQjItf71MHX5QIZ7SV6wdJe7Fc;Domain=.google.com;Path=/
    // - LSID=EXPIRED;Domain=.google.com;Path=/;Expires=Mon, 01-Jan-1990 00:00:00 GMT
    // - LSID=EXPIRED;Path=/;Expires=Mon, 01-Jan-1990 00:00:00 GMT
    // - LSID=EXPIRED;Domain=www.google.com;Path=/accounts;Expires=Mon, 01-Jan-1990 00:00:00 GMT
    // - LSID=DQAAAG4AAADanAEjtwRXL-iUy0157EqeFN43KNkGbZk-hIQSc69PDet5u4D8_RWv-1xb6u_3tTXvFO677EbXLDgY-yE8O0pdPutCZr92kPckOWjcXaMuKKuXcvQalb0GeEmK4cE_JQpJZ9iM8LRXInhARGOtiMpW;Path=/accounts;Secure
    // - GA3T=; Expires=Fri, 13-Apr-07 14:07:12 GMT; Path=/
    // - GoogleAccountsLocale_session=en

    // notable differences above between indy and firefox:
    // 1. indy uses http protocol 1.0 for POST (this can be forced by configuration to 1.1 if needed)
    // 2. indy also url encodes the "." in the post parameters
    // 3. server replies with an extra header element: "Connection: Close" (might be because of using 1.0 protocol)

    // now do the js redirect
    i:=posex('href=',html,pos('id="clickToContinue"', html))+6;
    url:=copy(html,i,posex('"',html,i)-i);

//    getPage('https:\\www.google.com\accounts\CheckCookie?continue=http%3A%2F%2Fwww2.blogger.com%2Floginz%3Fd%3Dhttp%253A%252F%252Fwww2.blogger.com&service=blogger&hl=en&chtml=LoginDoneHtml&skipvpage=true&alinsu=1&naui=8');
    idhttp1.Request.Referer:='https://www.google.com/accounts/ServiceLoginBoxAuth';
    idhttp1.Request.ContentType:='';
    // send cookies:
    // GoogleAccountsLocale_session=en;
    // GA3T=r1jGWSDh6FA;
    // LSID=DQAAAG4AAADanAEjtwRXL-iUy0157EqeFN43KNkGbZk-hIQSc69PDet5u4D8_RWv-1xb6u_3tTXvFO677EbXLDgY-yE8O0pdPutCZr92kPckOWjcXaMuKKuXcvQalb0GeEmK4cE_JQpJZ9iM8LRXInhARGOtiMpW;
    // SID=DQAAAGoAAAAFMpqWBvaol9t61QDdcQkORiDRyy6laLqmxuWQ97Dcogq5o05Ndhmymk82SFnFVg6M0fveOe5ox4HQJsreaHZYAi1s3llAK27qh2usYkswJnSZVrd_Tx3XTk7OtxQQjItf71MHX5QIZ7SV6wdJe7Fc
    html:=getpage(url);
    // sets 5 cookies:
    // - GoogleAccountsLocale_session=en
    // - LSID=EXPIRED;Domain=.google.com;Path=/;Expires=Mon, 01-Jan-1990 00:00:00 GMT
    // - LSID=EXPIRED;Path=/;Expires=Mon, 01-Jan-1990 00:00:00 GMT
    // - LSID=EXPIRED;Domain=www.google.com;Path=/accounts;Expires=Mon, 01-Jan-1990 00:00:00 GMT
    // - LSID=blogger:DQAAAG4AAADanAEjtwRXL-iUy0157EqeFN43KNkGbZk-hIQSc69PDet5u4D8_RWv-1xb6u_3tTXvFO677EbXLDgY-yE8O0pdPutCZr92kPckOWjcXaMuKKuXcvQalb0GeEmK4cE_JQpJZ9iM8LRXInhARGOtiMpW;Path=/accounts;Secure

    // notable differences above between indy and firefox:
    // 1. firefox sends the cookie GA3T=r1jGWSDh6FA which my indy implementation doesn't. However, I'm not sure which one is correct.
    //    if you look at the previous get, the server returns GA3T=; Expires=Fri, 13-Apr-07 14:07:12 GMT; Path=/
    //    actually, it returns the expires field with one day before today, which basically means the cookie is epired.
    //    according to the 2109 RFC, if a cookie is received expired, then both the current cookie and existing cookie is discarded
    //    and thus not sent to the server (my understanding). more precisely, and I quote (section 4.3.3):
    //      If a user agent receives a Set-Cookie response header whose NAME is
    //      the same as a pre-existing cookie, and whose Domain and Path
    //      attribute values exactly (string) match those of a pre-existing
    //      cookie, the new cookie supersedes the old.  However, if the Set-
    //      Cookie has a value for Max-Age of zero, the (old and new) cookie is
    //      discarded.  Otherwise cookies accumulate until they expire (resources
    //      permitting), at which time they are discarded.
    
//    i:=pos('location.replace(',html)+18;//18=length(location.replace(")
    i:=pos('url=',html)+5;//18=length(url=')
    url:=copy(html,i,posex('''',html,i)-i);

    url:=stringreplace(url,'&amp;', '&', [rfReplaceAll, rfIgnoreCase]);
    idhttp1.Request.Referer:='';
{    idhttp1.Request.CustomHeaders.Delete(idhttp1.Request.CustomHeaders.IndexOfName('Connection'));
    idhttp1.Request.CustomHeaders.Add('Connection: keep-alive'); {}
    // above is attempt to overcome firefox difference explained below at differences
    // send cookies:
    // S=blogger=GZToBYmGIRnzcAWwVvqszQ;
    // __utma=238348806.1200250844.1176559960.1176559960.1176559960.1;
    // __utmb=238348806;
    // __utmc=238348806;
    // __utmz=238348806.1176559960.1.1.utmccn=(direct)|utmcsr=(direct)|utmcmd=(none)
    html:=getpage(url);
    // sets 2 cookies:
    // - blogger_SID=DQAAAGwAAADDmZaiK1xHJTugfyJtyOZgkG-BcrPo5LUe3XW7IAMNVwqf2GxlprOjXlOzJG0fqa88mX8uotyGmfoh_Nl5lGkhJO-Ui4lnZHCecmL2X_tQ-VBnVQHjxa4Tr_Zr0OO23Obc5f_0_PbVnSbxh_N4RTwV; Domain=.blogger.com; Path=/
    // - B2I=Ciuly; Domain=.blogger.com
    // + redirects (302) to http://www2.blogger.com

    // notable differences above between indy and firefox:
    // 1. firefox, through paros, sends a header "Proxy-Connection: keep-alive", whereas indy remains at "Connection: keep-alive"
    //    I tried a small fix, commented above, but it doesn't seem to work. since this session returned the correct cookies and
    //    kept me logged in, I decided not to spend time on solving this as it might not even be a problem

    // send cookies:
    // S=blogger=GZToBYmGIRnzcAWwVvqszQ;
    // __utma=238348806.1200250844.1176559960.1176559960.1176559960.1;
    // __utmb=238348806;
    // __utmc=238348806;
    // __utmz=238348806.1176559960.1.1.utmccn=(direct)|utmcsr=(direct)|utmcmd=(none);
    // blogger_SID=DQAAAGwAAADDmZaiK1xHJTugfyJtyOZgkG-BcrPo5LUe3XW7IAMNVwqf2GxlprOjXlOzJG0fqa88mX8uotyGmfoh_Nl5lGkhJO-Ui4lnZHCecmL2X_tQ-VBnVQHjxa4Tr_Zr0OO23Obc5f_0_PbVnSbxh_N4RTwV;
    // B2I=Ciuly
//    html:=getpage('http://www2.blogger.com');
// not needed, as it is deon by the redirect
    // doesn't set any cookie
    // + redirects (302) to http://www2.blogger.com/home

    // send cookies:
    // S=blogger=GZToBYmGIRnzcAWwVvqszQ;
    // __utma=238348806.1200250844.1176559960.1176559960.1176559960.1;
    // __utmb=238348806;
    // __utmc=238348806;
    // __utmz=238348806.1176559960.1.1.utmccn=(direct)|utmcsr=(direct)|utmcmd=(none);
    // blogger_SID=DQAAAGwAAADDmZaiK1xHJTugfyJtyOZgkG-BcrPo5LUe3XW7IAMNVwqf2GxlprOjXlOzJG0fqa88mX8uotyGmfoh_Nl5lGkhJO-Ui4lnZHCecmL2X_tQ-VBnVQHjxa4Tr_Zr0OO23Obc5f_0_PbVnSbxh_N4RTwV;
    // B2I=Ciuly
//    html:=getpage('http://www2.blogger.com/home');
// not needed, as it is deon by the redirect

    // doesn't set any cookie

    except on e: EIdHTTPProtocolException do
            begin
                memo1.lines.add(idHTTP1.response.ResponseText);
                memo1.lines.add(e.ErrorMessage);
            end;
       end;
    Params.Free;
    memo1.Lines.Text:=html;
    showmessage('Logged in? '+booltostr(pos('<a href="/logout.g">Sign out</a>', html)>0,true));
end;

end.
